diff --git a/gdb/testsuite/gdb.python/py-cmd.exp b/gdb/testsuite/gdb.python/py-cmd.exp
index d2d8205446..33a5b39842 100644
--- a/gdb/testsuite/gdb.python/py-cmd.exp
+++ b/gdb/testsuite/gdb.python/py-cmd.exp
@@ -188,44 +188,45 @@ gdb_test "complete expr_test bar\." \
 # the easiest way is just to test with Python.
 proc test_python_inline_or_multiline { } {
     global gdb_prompt
+    set end "\r\n$gdb_prompt $"
 
-    set define_cmd_not_inline {
-	{ "if 1"                 " >$"            "multi-line if 1" }
-	{ "python"               " >$"            "multi-line python command" }
-	{ "print ('hello')"      "  >$"           "multi-line print" }
-	{ "end"                  " >$"            "multi-line first end" }
-	{ "end"                  "hello\r\n"      "multi-line last end" } }
+    set define_cmd_not_inline [ list \
+	[ list "if 1"                 " >$"            "multi-line if 1" ] \
+	[ list "python"               " >$"            "multi-line python command" ] \
+	[ list "print ('hello')"      "  >$"           "multi-line print" ] \
+	[ list "end"                  " >$"            "multi-line first end" ] \
+	[ list "end"                  "hello$end"      "multi-line last end" ] ]
 
     # This also tests trailing whitespace on the command.
-    set define_cmd_alias_not_inline {
-	{ "if 1"                 " >$"            "multi-line if 1 alias" }
-	{ "py    "               " >$"            "multi-line python command alias" }
-	{ "print ('hello')"      "  >$"           "multi-line print alias" }
-	{ "end"                  " >$"            "multi-line first end alias" }
-	{ "end"                  "hello\r\n"      "multi-line last end alias" } }
-
-    set define_cmd_alias_foo_not_inline {
-	{ "alias foo=python"     "\r\n"           "multi-line alias foo" }
-	{ "if 1"                 " >$"            "multi-line if 1 alias foo" }
-	{ "foo    "              " >$"            "multi-line python command alias foo" }
-	{ "print ('hello')"      "  >$"           "multi-line print alias foo" }
-	{ "end"                  " >$"            "multi-line first end alias foo" }
-	{ "end"                  "hello\r\n"      "multi-line last end alias foo" } }
-
-    set define_cmd_inline {
-	{ "if 1"                      " >$"          "inline if 1" }
-	{ "python print ('hello')"    " >$"          "inline python command" }
-	{ "end"                       "hello\r\n"    "inline end" } }
-
-    set define_cmd_alias_inline {
-	{ "if 1"                      " >$"          "inline if 1 alias" }
-	{ "py print ('hello')"        " >$"          "inline python command alias" }
-	{ "end"                       "hello\r\n"    "inline end alias" } }
-
-    set define_cmd_alias_foo_inline {
-	{ "if 1"                      " >$"          "inline if 1 alias foo" }
-	{ "foo print ('hello')"       " >$"          "inline python command alias foo" }
-	{ "end"                       "hello\r\n"    "inline end alias foo" } }
+    set define_cmd_alias_not_inline [ list \
+	[ list "if 1"                 " >$"            "multi-line if 1 alias" ] \
+	[ list "py    "               " >$"            "multi-line python command alias" ] \
+	[ list "print ('hello')"      "  >$"           "multi-line print alias" ] \
+	[ list "end"                  " >$"            "multi-line first end alias" ] \
+	[ list "end"                  "hello$end"      "multi-line last end alias" ] ]
+
+    set define_cmd_alias_foo_not_inline [ list \
+	[ list "alias foo=python"     "$end"           "multi-line alias foo" ] \
+	[ list "if 1"                 " >$"            "multi-line if 1 alias foo" ] \
+	[ list "foo    "              " >$"            "multi-line python command alias foo" ] \
+	[ list "print ('hello')"      "  >$"           "multi-line print alias foo" ] \
+	[ list "end"                  " >$"            "multi-line first end alias foo" ] \
+	[ list "end"                  "hello$end"      "multi-line last end alias foo" ] ]
+
+    set define_cmd_inline [ list \
+	[ list "if 1"                      " >$"          "inline if 1" ] \
+	[ list "python print ('hello')"    " >$"          "inline python command" ] \
+	[ list "end"                       "hello$end"    "inline end" ] ]
+
+    set define_cmd_alias_inline [ list \
+	[ list "if 1"                      " >$"          "inline if 1 alias" ] \
+	[ list "py print ('hello')"        " >$"          "inline python command alias" ] \
+	[ list "end"                       "hello$end"    "inline end alias" ] ]
+
+    set define_cmd_alias_foo_inline [ list \
+	[ list "if 1"                      " >$"          "inline if 1 alias foo" ] \
+	[ list "foo print ('hello')"       " >$"          "inline python command alias foo" ] \
+	[ list "end"                       "hello$end"    "inline end alias foo" ] ]
 
     foreach t [list $define_cmd_not_inline \
 	       $define_cmd_alias_not_inline \